Loading...
Searching...
No Matches
wayland::server::zxdg_output_v1_t Class Reference

compositor logical output region More...

`#include <wayland-server-protocol-unstable.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void()> & | on_destroy ()
| destroy the xdg_output object
void | logical_position (int32_t x, int32_t y, bool post=true)
| position of the output within the global compositor space
void | logical_size (int32_t width, int32_t height, bool post=true)
| size of the output in the global compositor space
void | done (bool post=true)
| all information about the output have been sent
void | name (std::string const &name, bool post=true)
| name of this output
bool | can_name () const
| Check whether the name function is available with the currently bound version of the protocol.
void | description (std::string const &description, bool post=true)
| human-readable description of this output
bool | can_description () const
| Check whether the description function is available with the currently bound version of the protocol.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | logical_position_since_version = 1
| Minimum protocol version required for the logical_position function.
static constexpr std::uint32_t | logical_size_since_version = 1
| Minimum protocol version required for the logical_size function.
static constexpr std::uint32_t | done_since_version = 1
| Minimum protocol version required for the done function.
static constexpr std::uint32_t | name_since_version = 2
| Minimum protocol version required for the name function.
static constexpr std::uint32_t | description_since_version = 2
| Minimum protocol version required for the description function.

## Detailed Description

compositor logical output region

An xdg_output describes part of the compositor geometry.

This typically corresponds to a monitor that displays part of the compositor space.

For objects version 3 onwards, after all xdg_output properties have been sent (when the object is created and when properties are updated), a wl_output.done event is sent. This allows changes to the output properties to be seen as atomic, even if they happen via multiple events.

Definition at line 8563 of file wayland-server-protocol-unstable.hpp.

## Member Function Documentation

## can_description()

bool zxdg_output_v1_t::can_description | ( |  | ) | const

Check whether the description function is available with the currently bound version of the protocol.

Definition at line 8149 of file wayland-server-protocol-unstable.cpp.

## can_name()

bool zxdg_output_v1_t::can_name | ( |  | ) | const

Check whether the name function is available with the currently bound version of the protocol.

Definition at line 8139 of file wayland-server-protocol-unstable.cpp.

## description()

void zxdg_output_v1_t::description | ( | std::string const & | description,
|  | bool | post = `true`
| ) |  |

human-readable description of this output

Parameters

  description | output description

Many compositors can produce human-readable descriptions of their outputs. The client may wish to know this description as well, to communicate the user for various purposes.

The description is a UTF-8 string with no convention defined for its contents. Examples might include 'Foocorp 11" Display' or 'Virtual X11 output via :1'.

The description event is sent after creating an xdg_output (see xdg_output_manager.get_xdg_output) and whenever the description changes. The description is optional, and may not be sent at all.

For objects of version 2 and lower, this event is only sent once per xdg_output, and the description does not change over the lifetime of the wl_output global.

Definition at line 8144 of file wayland-server-protocol-unstable.cpp.

## done()

void zxdg_output_v1_t::done | ( | bool | post = `true` | ) |

all information about the output have been sent

This event is sent after all other properties of an xdg_output have been sent.

This allows changes to the xdg_output properties to be seen as atomic, even if they happen via multiple events.

For objects version 3 onwards, this event is deprecated. Compositors are not required to send it anymore and must send wl_output.done instead.

Definition at line 8129 of file wayland-server-protocol-unstable.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## logical_position()

void zxdg_output_v1_t::logical_position | ( | int32_t | x,
|  | int32_t | y,
|  | bool | post = `true`
| ) |  |

position of the output within the global compositor space

Parameters

  x | x position within the global compositor space
  y | y position within the global compositor space

The position event describes the location of the wl_output within the global compositor space.

The logical_position event is sent after creating an xdg_output (see xdg_output_manager.get_xdg_output) and whenever the location of the output changes within the global compositor space.

Definition at line 8119 of file wayland-server-protocol-unstable.cpp.

## logical_size()

void zxdg_output_v1_t::logical_size | ( | int32_t | width,
|  | int32_t | height,
|  | bool | post = `true`
| ) |  |

size of the output in the global compositor space

Parameters

  width | width in global compositor space
  height | height in global compositor space

The logical_size event describes the size of the output in the global compositor space.

For example, a surface without any buffer scale, transformation nor rotation set, with the size matching the logical_size will have the same size as the corresponding output when displayed.

Most regular Wayland clients should not pay attention to the logical size and would rather rely on xdg_shell interfaces.

Some clients such as Xwayland, however, need this to configure their surfaces in the global compositor space as the compositor may apply a different scale from what is advertised by the output scaling property (to achieve fractional scaling, for example).

For example, for a wl_output mode 3840×2160 and a scale factor 2:

- A compositor not scaling the surface buffers will advertise a logical size of 3840×2160,
- A compositor automatically scaling the surface buffers will advertise a logical size of 1920×1080,
- A compositor using a fractional scale of 1.5 will advertise a logical size of 2560×1440.

For example, for a wl_output mode 1920×1080 and a 90 degree rotation, the compositor will advertise a logical size of 1080x1920.

The logical_size event is sent after creating an xdg_output (see xdg_output_manager.get_xdg_output) and whenever the logical size of the output changes, either as a result of a change in the applied scale or because of a change in the corresponding output mode(see wl_output.mode) or transform (see wl_output.transform).

Definition at line 8124 of file wayland-server-protocol-unstable.cpp.

## name()

void zxdg_output_v1_t::name | ( | std::string const & | name,
|  | bool | post = `true`
| ) |  |

name of this output

Parameters

  name | output name

Many compositors will assign names to their outputs, show them to the user, allow them to be configured by name, etc. The client may wish to know this name as well to offer the user similar behaviors.

The naming convention is compositor defined, but limited to alphanumeric characters and dashes (-). Each name is unique among all wl_output globals, but if a wl_output global is destroyed the same name may be reused later. The names will also remain consistent across sessions with the same hardware and software configuration.

Examples of names include 'HDMI-A-1', 'WL-1', 'X11-1', etc. However, do not assume that the name is a reflection of an underlying DRM connector, X11 connection, etc.

The name event is sent after creating an xdg_output (see xdg_output_manager.get_xdg_output). This event is only sent once per xdg_output, and the name does not change over the lifetime of the wl_output global.

Definition at line 8134 of file wayland-server-protocol-unstable.cpp.

## on_destroy()

std::function< void()> & zxdg_output_v1_t::on_destroy | ( |  | ) |

destroy the xdg_output object

Using this request a client can tell the server that it is not going to use the xdg_output object anymore.

Definition at line 8113 of file wayland-server-protocol-unstable.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## Member Data Documentation

## description_since_version

constexpr std::uint32_t wayland::server::zxdg_output_v1_t::description_since_version = 2

static constexpr

Minimum protocol version required for the description function.

Definition at line 8738 of file wayland-server-protocol-unstable.hpp.

## done_since_version

constexpr std::uint32_t wayland::server::zxdg_output_v1_t::done_since_version = 1

static constexpr

Minimum protocol version required for the done function.

Definition at line 8678 of file wayland-server-protocol-unstable.hpp.

## logical_position_since_version

constexpr std::uint32_t wayland::server::zxdg_output_v1_t::logical_position_since_version = 1

static constexpr

Minimum protocol version required for the logical_position function.

Definition at line 8613 of file wayland-server-protocol-unstable.hpp.

## logical_size_since_version

constexpr std::uint32_t wayland::server::zxdg_output_v1_t::logical_size_since_version = 1

static constexpr

Minimum protocol version required for the logical_size function.

Definition at line 8659 of file wayland-server-protocol-unstable.hpp.

## name_since_version

constexpr std::uint32_t wayland::server::zxdg_output_v1_t::name_since_version = 2

static constexpr

Minimum protocol version required for the name function.

Definition at line 8707 of file wayland-server-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp